package dev.peerat.parser.java.builder;

import dev.peerat.parser.Token;
import dev.peerat.parser.java.Import;

public class JavaImportBuilder extends JavaBuilder<Import>{

	private boolean isStatic;
	private String value;
	
	public JavaImportBuilder setStatic(){
		this.isStatic = true;
		return this;
	}
	
	public JavaImportBuilder setImport(String value){
		this.value = value;
		return this;
	}
	
	public JavaImportBuilder normalize(Import imp){
		this.isStatic = imp.isStatic();
		this.value = imp.getValue().getValue();
		return this;
	}
	
	@Override
	public Import build(){
		return new Import(this.isStatic, new Token(0,0,this.value, null));
	}

}
