package dev.peerat.parser.java.builder;

import dev.peerat.parser.java.JavaElement;

public abstract class JavaModifiableBuilder<T, E extends JavaElement> extends JavaBuilder<E>{
	
	//TODO TO TEST
	protected int mod;
	
	public T setPublic(){
		this.mod += 0x1;
		return (T) this;
	}
	
	public T setPrivate(){
		this.mod += 0x2;
		return (T) this;
	}
	
	public T setProtected(){
		this.mod += 0x4;
		return (T) this;
	}
	
	public T setStatic(){
		this.mod += 0x8;
		return (T) this;
	}
	
	public T setFinal(){
		this.mod += 0x10;
		return (T) this;
	}
	
	public T setSynchronized(){
		this.mod += 0x20;
		return (T) this;
	}
	
	public T setVolatile(){
		this.mod += 0x40;
		return (T) this;
	}
	
	public T setTransient(){
		this.mod += 0x80;
		return (T) this;
	}
	
	public T setNative(){
		this.mod += 0x100;
		return (T) this;
	}
	
	public T setAbstract(){
		this.mod += 0x400;
		return (T) this;
	}
	
	public T setStrict(){
		this.mod += 0x800;
		return (T) this;
	}
	
	public T setPackageLevel(){
//		this.mod += 0x1;
		return (T) this;
	}

}
