package dev.peerat.parser.java.tree;

import java.util.function.BiConsumer;

import dev.peerat.parser.Bag;
import dev.peerat.parser.Token;
import dev.peerat.parser.TokenType;
import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.state.StateTree;
import dev.peerat.parser.tree.SyntaxTree;
import dev.peerat.parser.tree.SyntaxTreeRegistery;

public class TypeTree extends SyntaxTree<JavaElement> {

	public TypeTree(SyntaxTreeRegistery<JavaElement> registery) {
		super(registery);
		this.current = new StateTree<>();
	}

	@Override
	public void init() {
		StateTree<JavaElement> gen = registery.getNode(GenericTree.class);
		// TYPE
		BiConsumer<Bag, Token> concat = (bag, token) -> {
			Token value = bag.get();
			if (value == null)
				bag.set(token);
			else
				bag.set(value.concat(token));
		};

		StateTree<JavaElement> type = this.current;
		StateTree<JavaElement> type_ = type
				.then((validator) -> validator.validate((token) -> token.getType().equals(TokenType.NAME), concat));
//				type_.then((validator) -> validator.validate((token) -> token.getValue().equals("."), concat)) //only dot?
//					.then(type_);
		type_.then(gen);

		StateTree<JavaElement> type_array_begin = type_
				.then((validator) -> validator.validate((token) -> token.getValue().equals("[")));
		StateTree<JavaElement> type_array_end = type_array_begin
				.then((validator) -> validator.validate((token) -> token.getValue().equals("]")));
		type_array_end.then(type_array_begin);
		type_array_end.end();

		type_.end();
	}

}
