package dev.peerat.parser.java.visitor;

import java.util.function.Predicate;

import dev.peerat.parser.java.Import;
import dev.peerat.parser.visitor.VisitorBag;

public class JavaImportVisitor extends JavaVisitor<Import>{
	
	//TODO CONCAT PREDICATE
	
	private Predicate<String> namePredicate;
	private boolean staticPredicate;
	private boolean nonStaticPredicate;
	
	public JavaImportVisitor(boolean propagate){
		super(Import.class, propagate);
	}
	
	public JavaImportVisitor named(Predicate<String> predicate){
		this.namePredicate = predicate;
		return this;
	}
	
	public JavaImportVisitor isStatic(){
		this.staticPredicate = true;
		this.nonStaticPredicate = false;
		return this;
	}
	
	public JavaImportVisitor isNotStatic(){
		this.staticPredicate = false;
		this.nonStaticPredicate = true;
		return this;
	}
	
	@Override
	public VisitorBag visitElement(Import element){
		VisitorBag bag = new VisitorBag();
		
		if(this.namePredicate != null){
			if(!this.namePredicate.test(element.getValue().getValue())) return bag;
		}
		
		if((staticPredicate && !element.isStatic()) || (nonStaticPredicate && element.isStatic())) return bag;
		
		bag.compute(element);
		return bag;
	}

}
