package dev.peerat.parser.state;

import java.util.function.Function;
import java.util.function.Predicate;

import dev.peerat.parser.TokenValidator;

public class BinaryStateTree<E> extends StateTree<E>{

	private Predicate<TokenValidator> condition;
	
	private StateTree<E> success;
	private StateTree<E> fail;
	
	public BinaryStateTree(Predicate<TokenValidator> checker){
		super();
		
		this.condition = checker;
	}

	@Override
	BuilderStateTree<E, ?> internalSeed(TokenValidator validator, E element){
		return ((this.condition.test(validator)) ? success : fail).internalSeed(validator, element);
	}
	
	public StateTree<E> success(StateTree<E> state){
		success = state;
		return state;
	}
	
	public StateTree<E> fail(StateTree<E> state){
		fail = state;
		return state;
	}
}
